/* PropCS_RTC.c */

#include <stdio.h>
#include <propeller.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/rtc.h>
#include <cog.h>
#include <ctype.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/sd.h>

#define BUFFERLEN 10

void PrintTime()
{
    time_t now;
    now = time(NULL);
    printf("%s", asctime(localtime(&now)));
}


int PromptTime(char *prompt)
{
    int rc = 0;
    char *endp;
    char buffer[BUFFERLEN];

    do {
        printf("Enter %s: ", prompt);
        fflush(stdout);

        fgets(buffer, BUFFERLEN, stdin);
        fflush(stdin);

        rc = strtol(buffer, &endp, 10);

        if (endp == buffer)
        {
            if ('\n' == *endp)
            {
                rc = 0;
                break;
            }
            printf("Invalid entry \"%c....\" Please enter a number.\n", *endp);
        }

    } while (endp == buffer);

    return rc;
}

int getdst()
{
    int rc = 0;
    printf("Use daylight savings time [y/n] ? ");
    fflush(stdout);

    rc = (getchar() == 'y') ? 1 : 0;
    getchar();

    return rc;
}

void SetTime()
{
    struct timeval tv;
    struct tm t;

    t.tm_isdst = getdst();
    t.tm_year = PromptTime("Year")-1900;
    t.tm_mon = PromptTime("Month")-1;
    t.tm_mday = PromptTime("Day of the month");
    t.tm_hour = PromptTime("Hour");
    t.tm_min = PromptTime("Minute");
    t.tm_sec = PromptTime("Second");

    tv.tv_sec = mktime(&t);
    settimeofday(&tv, 0);

    printf("Set time all done.\n");
}


void ManTime()
{
    printf("Time - displays the current date and time, if the time has been set.\n");
}

void ManSetTime()
{
    printf("SetTime - sets the system time. Will be prompted for data entry.\n");
}
